<?php

/**
 * 1-language_structures.php
 *
 * 言語構造の使用例を紹介します
 */

// declare — 内側に = を書くのが独特です
declare(ticks=10);
declare(strict_types=1);



// array — これも関数ではありません
$a = array(1, 2, 3); // [1, 2, 3] と同じ
$b = array('key' => 'value'); // ['key' => 'value'] と同じ
// [1, 2, 3] の形式の短い文法はPHP 5.4で追加されました



$c = 3;

// そういえばif文も関数呼び出しではありませんね
if($c == 1)
    // exit文 — PHPスクリプトの実行を終了します
    // 引数の数字はステータスコードで、0が正常終了です
    exit(0);
elseif($c == 2) {
    // die文 — exitと同じ意味です
    // func() が実行失敗したらスクリプトを異常終了する、というニュアンスです
    func() or die(1);
}

// xxxx or die() かっこいいので書いてしまいたくなるのですが、
// スクリプトの終了場所がわかりにくくなるので throw new \Exception(); の方が良いです



// echo文 — 文字列を標準出力します
echo("Hoge, ");
// 関数っぽくない書きかたをすると、値をいくつも渡せます
echo "fuga", " and ", "piyo", PHP_EOL;

// echo を関数っぽく書くときは値をひとつしか渡せません
// echo(1, 2); ← これは Syntax error



// print — 文字列を標準出力します
// echoとの違いは、式の内側に書けること、引数を常にひとつしか受け取れないことです。
(mt_rand(0, 1) == 0) ? print("hoge\n") : print("fuga\n");
(mt_rand(0, 1) == 1) ? print "hoge\n"  : print "fuga\n";

// これは別にSyntax errorではありません (メリットもありません)
echo print 'abc', PHP_EOL;



// list — 配列の中身を個別の変数に代入することができます
// この構文の詳細についてはWeb上に紹介記事を書きました
// @see http://qiita.com/tadsan/items/0beaf61747397c1e3db8
$arr = array(1, 2, 3);
list($d, $e, $f) = $arr;

function x()
{
    return array('a', 'b', 'c');
}
