<?php

/**
 * error_reporting(0); で全てのエラーを捕捉しないようにする
 *
 *    php ./error_reporting_0.php
 */

error_reporting(0);

$foo = "Foo";
define('BAR', 'Bar');
$buz = ['x' => 'BuzX', 'y' => 'BuzY'];

// 正常に出力される
echo $foo, PHP_EOL;
echo BAR, PHP_EOL;
echo $buz['x'];

// 未定義変数、改行だけ出力される
echo $fo0, PHP_EOL;

// 未定義定数だがFooと出力される
echo Foo, PHP_EOL;

// うっかり $ をふたつ重ねてしまって、意図せず可変変数になってしまった
echo $$foo, PHP_EOL;

// 正常に出力されるが、未定義定数を使ってしまっている
echo $buz[y], PHP_EOL; // $buz['y'] が正しい

// 未定義関数を実行する
hoge();

echo "この行は実行されない", PHP_EOL;
