<?php

/**
 * error_reporting(E_ALL); で全てのエラーを捕捉する
 *
 * 未定義変数などバグを誘発しうる、開発時には有用な情報を警告します。
 *
 *    php ./error_reporting_e_all.php
 */

error_reporting(E_ALL);

$foo = "Foo";
define('BAR', 'Bar');
$buz = ['x' => 'BuzX', 'y' => 'BuzY'];

// 正常に出力される
echo $foo, PHP_EOL;
echo BAR, PHP_EOL;

// 未定義変数
echo $fo0, PHP_EOL;

// 未定義定数
echo Foo, PHP_EOL;

// うっかり $ をふたつ重ねてしまった
// PHP Notice:  Undefined variable: Foo として報告される
echo $$foo, PHP_EOL;

// yが未定義定数
echo $buz[y], PHP_EOL; // $buz['y'] が正しい

// 未定義関数を実行する
hoge();

// ↑ここでFatal errorが発生する
// PHP Fatal error:  Uncaught Error: Call to undefined function hoge()

echo "この行は実行されない", PHP_EOL;
